package org.jamon.node;

import org.jamon.api.Location;
public class EscapeDirectiveNode extends AbstractNode
{
  public EscapeDirectiveNode(Location p_location, String p_escapeCode)
  {
    super(p_location);
    if ((m_escapeCode = p_escapeCode) == null)
      { throw new NullPointerException(); }
  }

  @Override public void apply(Analysis p_analysis)
  {
    p_analysis.caseEscapeDirectiveNode(this);
  }

  private final String m_escapeCode;
  public String getEscapeCode() { return m_escapeCode; }

  @Override public boolean equals(Object p_obj)
  {
    return p_obj != null
        && super.equals(p_obj)
      && m_escapeCode.equals(((EscapeDirectiveNode) p_obj).m_escapeCode)
    ;
  }

  @Override public int hashCode()
  {
    return super.hashCode()
      ^ m_escapeCode.hashCode()
    ;
  }

  @Override protected void propertiesToString(StringBuilder p_buffer)
  {
    super.propertiesToString(p_buffer);
    addProperty(p_buffer, "escapeCode", m_escapeCode);
  }

}
