package org.jamon.node;

import org.jamon.api.Location;
public class ExtendsNode extends AbstractNode
{
  public ExtendsNode(Location p_location, AbstractPathNode p_path)
  {
    super(p_location);
    if ((m_path = p_path) == null)
      { throw new NullPointerException(); }
  }

  @Override public void apply(Analysis p_analysis)
  {
    p_analysis.caseExtendsNode(this);
  }

  private final AbstractPathNode m_path;
  public AbstractPathNode getPath() { return m_path; }

  @Override public boolean equals(Object p_obj)
  {
    return p_obj != null
        && super.equals(p_obj)
      && m_path.equals(((ExtendsNode) p_obj).m_path)
    ;
  }

  @Override public int hashCode()
  {
    return super.hashCode()
      ^ m_path.hashCode()
    ;
  }

  @Override protected void propertiesToString(StringBuilder p_buffer)
  {
    super.propertiesToString(p_buffer);
    addProperty(p_buffer, "path", m_path);
  }

}
