package org.jamon.node;

import org.jamon.api.Location;
public class FragmentCallNode extends AbstractComponentCallNode
{
  public FragmentCallNode(Location p_location, AbstractPathNode p_callPath, AbstractParamsNode p_params, UnnamedFragmentNode p_fragment)
  {
    super(p_location, p_callPath, p_params);
    if ((m_fragment = p_fragment) == null)
      { throw new NullPointerException(); }
  }

  @Override public void apply(Analysis p_analysis)
  {
    p_analysis.caseFragmentCallNode(this);
  }

  private final UnnamedFragmentNode m_fragment;
  public UnnamedFragmentNode getFragment() { return m_fragment; }

  @Override public boolean equals(Object p_obj)
  {
    return p_obj != null
        && super.equals(p_obj)
      && m_fragment.equals(((FragmentCallNode) p_obj).m_fragment)
    ;
  }

  @Override public int hashCode()
  {
    return super.hashCode()
      ^ m_fragment.hashCode()
    ;
  }

  @Override protected void propertiesToString(StringBuilder p_buffer)
  {
    super.propertiesToString(p_buffer);
    addProperty(p_buffer, "fragment", m_fragment);
  }

}
