package org.jamon.node;

import org.jamon.api.Location;
public class ParentArgNode extends AbstractNode
{
  public ParentArgNode(Location p_location, ArgNameNode p_name)
  {
    super(p_location);
    if ((m_name = p_name) == null)
      { throw new NullPointerException(); }
  }

  @Override public void apply(Analysis p_analysis)
  {
    p_analysis.caseParentArgNode(this);
  }

  private final ArgNameNode m_name;
  public ArgNameNode getName() { return m_name; }

  @Override public boolean equals(Object p_obj)
  {
    return p_obj != null
        && super.equals(p_obj)
      && m_name.equals(((ParentArgNode) p_obj).m_name)
    ;
  }

  @Override public int hashCode()
  {
    return super.hashCode()
      ^ m_name.hashCode()
    ;
  }

  @Override protected void propertiesToString(StringBuilder p_buffer)
  {
    super.propertiesToString(p_buffer);
    addProperty(p_buffer, "name", m_name);
  }

}
